<template>
  <single-pane :capt="dictionaryRu.title">
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getObTableData"
      :show-add-button="true"
      is-fixed-header
      @select="onSelection"
      @add="onAdd"
      ref="obTable"
    />
    <ob-modal
      ref="viewItem"
      :title="dictionaryRu.modal.title"
      custom-class="modal-large"
      :is-show-pagination="!newStatus"
      :is-show-controls="false"
    >
      <pattern-modal
        :data-source="selectedData"
        :mask-list="maskList"
        :api="api"
        @submit="preparedSave"
        @delete="onDelete"
        @refresh="onRefresh"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import api from '@/api';
import paging from '@/mixins/dictionaries/paging';
import itemMixin from '@/mixins/dictionaries/edit-item';
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import PatternModal from './modal/Pattern';
import models from '@/models';
import ObModal from 'common-components/src/obComponents/obModal';
import ObTable from 'common-components/src/obComponents/obTable';
import { dictionaryDefault } from '@/translations/ru/default';
import { dictionary } from '@/translations/ru/dictionaries__resources__patterns';

export default {
  name: 'Patterns',
  components: {
    ObModal,
    PatternModal,
    ObTable,
    SinglePane
  },
  mixins: [paging, itemMixin],
  computed: {
    isNew() {
      return !this.selectedData.uuid;
    },
    formModel() {
      return models.patterns.add;
    },
    columnsObTable() {
      let _self = this;
      return [
        {
          title: this.dictionaryRu.columns.mask,
          key: 'maskUuid',
          html: function(data) {
            if (data.maskUuid) {
              let mask = _self.maskList.find(m => m.uuid === data.maskUuid);
              if (mask) {
                let _mask = mask.mask;
                for (let key in data.parameters) {
                  _mask = _mask.replace(key, data.parameters[key]);
                }
                return _mask;
              }
              return '';
            }
            return '';
          }
        },
        {
          title: this.dictionaryRu.columns.status,
          width: 110,
          key: 'isActive',
          html: data => {
            return !data.isActive
              ? this.dictionaryRu.status.inactive
              : this.dictionaryRu.status.active;
          }
        }
      ];
    }
  },
  mounted() {
    //TODO 100
    api.resources
      .getPatternMasks(false, 0, 100, '')
      .then(({ data }) => {
        this.maskList = data.content;
      })
      .catch(e => {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      });
  },
  data() {
    return {
      dictionaryRu: Object.assign(dictionary, dictionaryDefault),
      maskList: [],
      dataGridRefName: 'Patterns',
      api: {
        source: 'oboz2-dictionary-resource-patterns-crud/v1/'
      }
    };
  },
  methods: {
    preparedSave(payload) {
      this.onSave(payload);
    }
  }
};
</script>

<style scoped>
</style>
